--[[
	Name: Classic DCoords
	Author: Darcey.Lloyd@gmail.com

	USEFUL TO GET FRAME NAME IN GAME CHAT:
	/run print(GetMouseFocus():GetName() .. "\n")
--]]

-- Addon Global Variables (shared between files but not addons). addon var name can be renamed
local AddOnName, addon = ...;
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- addon.init
addon.init = function()
	-- force a hard reset of DCoordsDB
	-- DCoordsDB = nil;

	-- Setup
	addon.initPersistentVars();
	addon.setupGUI();
	addon.setupMenu();

	-- state
	addon.setInitialState();


	-- Setup slash commands
	SlashCmdList["DGPSCOMMAND"] = addon.slashCommandHandler;
	SLASH_DGPSCOMMAND1 = "/dgps";

	-- Welcome message
	print(" ")
	DTools.log("DGPS: Type /dgps for options","00CC00")

	-- init complete flag
	addon.initComplete = true;

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- addon.slashCommandHandler
addon.slashCommandHandler = function(cmd)
	if (addon.debug) then
		print("addon.slashCommandHandler(cmd:" .. cmd ..")");
	end

	-- Open DCoords menu, open sub menu and then back to root page
	InterfaceOptionsFrame_OpenToCategory(addon.menu.mainPage.name);
	InterfaceOptionsFrame_OpenToCategory(addon.menu.mainPage.name);
	InterfaceOptionsFrame_OpenToCategory(addon.menu.mainPage.name);
	-- InterfaceOptionsFrame_OpenToCategory(addon.menu.mainBar.name);
	-- InterfaceOptionsFrame_OpenToCategory(addon.menu.mainPage.name);
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- This should be done last so everything is available to it
addon.frames.eventFrame = CreateFrame("frame","ClassiDCCoordsEventFrame");
addon.frames.eventFrame:RegisterEvent("VARIABLES_LOADED");
addon.frames.eventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
addon.frames.eventFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
addon.frames.eventFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
addon.frames.eventFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
addon.frames.eventFrame:RegisterEvent("ZONE_CHANGED_INDOORS");
addon.frames.eventFrame:RegisterEvent("ZONE_CHANGED");
addon.frames.eventFrame:SetScript("OnEvent", function(self,event,addonName)
		if (event == "VARIABLES_LOADED") then
			if (addon.debug) then
				DTools.log("event:" .. event,"00CC00")
			end
			addon.init();
		elseif (event == "ZONE_CHANGED") then
			addon.getZoneDetails();
		elseif (event == "ZONE_CHANGED_NEW") then
			addon.getZoneDetails();
		elseif (event == "ZONE_CHANGED_NEW_AREA") then
			addon.getZoneDetails();
		elseif (event == "ZONE_CHANGED_INDOORS") then
			addon.getZoneDetails();
		end
	end
)
addon.frames.eventFrame:SetScript("OnUpdate",addon.onUpdateHandler)
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
