--[[
	Author: Darcey.Lloyd@gmail.com

	USEFUL TO GET FRAME NAME IN GAME CHAT:
	/run print(GetMouseFocus():GetName() .. "\n")
--]]



-- Addon Global Variables (shared between files but not addons). addon var name can be renamed
local AddOnName, addon = ...;
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #






-- setup mainFrame
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
addon.setupGUI = function()
	addon.setupInputFrame();
	addon.setupArrowFrame();

	-- input frame contents
	local x = 12;
	local y = -30;

	local onKeyUpHandler = function(self)
		-- self:HighlightText(0,0);
		-- self:SetCursorPosition(0);
		-- self:ClearFocus();
		addon.saveInputValues();
	end

	local onEditFocusLostHandler = function(self)
		-- self:HighlightText(0,0);
		-- self:SetCursorPosition(0);
		-- self:ClearFocus();
		addon.clearAllEditBoxFocus();
		addon.saveInputValues();
	end



	for i = 1, addon.inputFrame.rows, 1 do
		local onNameTabPressed = function(self)
			local index = i;
			local next = addon.inputFrame.inputX[index];
			next:SetFocus();
			next:HighlightText(0,0);
			next:SetCursorPosition(0);
			addon.saveInputValues();
		end

		local onXTabPressed = function(self)
			local index = i;
			local next = addon.inputFrame.inputY[index];
			next:SetFocus();
			next:HighlightText(0,0);
			next:SetCursorPosition(0);
			addon.saveInputValues();
		end

		local onYTabPressed = function(self)
			local index = i+1;
			if (index == 5) then
				index = 1;
			end
			local next = addon.inputFrame.inputName[index];
			next:SetFocus();
			next:HighlightText(0,0);
			next:SetCursorPosition(0);
			addon.saveInputValues();
		end

		addon.inputFrame.inputName[i] = addon.createEditBox(x,y,150,"LEFT",50);
		addon.inputFrame.inputName[i]:SetScript("OnKeyUp", onKeyUpHandler);
		addon.inputFrame.inputName[i]:SetScript("OnTabPressed", onNameTabPressed);
		addon.inputFrame.inputName[i]:SetScript("OnEnterPressed", onEditFocusLostHandler);
		-- addon.inputFrame.inputName[i]:SetScript("OnEditFocusLost", onEditFocusLostHandler);


		addon.inputFrame.inputX[i] = addon.createEditBox(x+160,y,50,"CENTER",5);
		addon.inputFrame.inputX[i]:SetScript("OnKeyUp", onKeyUpHandler);
		addon.inputFrame.inputX[i]:SetScript("OnTabPressed", onXTabPressed);
		addon.inputFrame.inputX[i]:SetScript("OnEnterPressed", onEditFocusLostHandler);
		-- addon.inputFrame.inputX[i]:SetScript("OnEditFocusLost", onEditFocusLostHandler);

		addon.inputFrame.inputY[i] = addon.createEditBox(x+220,y,50,"CENTER",5);
		addon.inputFrame.inputY[i]:SetScript("OnKeyUp", onKeyUpHandler);
		addon.inputFrame.inputY[i]:SetScript("OnTabPressed", onYTabPressed);
		addon.inputFrame.inputY[i]:SetScript("OnEnterPressed", onEditFocusLostHandler);
		-- addon.inputFrame.inputY[i]:SetScript("OnEditFocusLost", onEditFocusLostHandler);

		-- Checkbox click functions dynamic creation
		local fn = function(checked)
			local index = i;
			-- print("CB:" .. index .. " checked: "..DGPSTools.boolToString(checked));
			addon.checkboxClickHandler(index,checked);
		end

		--name,frame,label,x,y,checked,clickHandler,font,fontSize
		addon.inputFrame.checkBox[i] = DGPSTools.createCheckbox("CB"..i,addon.inputFrame.frame,"",x+270,y+4,false,fn)

		y = y - 20;
	end




end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #










-- setup mainFrame
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
addon.setupInputFrame = function()
    -- addon.inputFrame.frame
	addon.inputFrame.frame = CreateFrame("frame","DGPS_MainFrame",UIParent);
    addon.inputFrame.frame:SetFrameStrata("HIGH");
    addon.inputFrame.frame:EnableMouse(true);
	addon.inputFrame.frame:SetResizable(true);
	addon.inputFrame.frame:SetMovable(true);
    addon.inputFrame.frame:SetWidth(addon.inputFrame.frameW);
	addon.inputFrame.frame:SetHeight(addon.inputFrame.frameH);
	addon.inputFrame.frame:SetClampedToScreen(true)

	addon.inputFrame.frame:SetScale(0.8);

	-- addon.inputFrame.frame.texture = addon.inputFrame.frame:CreateTexture(nil, "BACKGROUND")
	-- addon.inputFrame.frame.texture:SetAllPoints(true)
	-- addon.inputFrame.frame.texture:SetColorTexture(1,0,0,1)

	local tileSize = 10;
	local edgeSize = 10;
	local insets = 3;

	addon.inputFrame.frame:SetBackdrop(nil); -- Hide/Remove classic frame
	addon.inputFrame.frame:SetBackdrop({
		bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = true, tileSize = tileSize, edgeSize = edgeSize,
		insets = { left = insets, right = insets, top = insets, bottom = insets }
	})

	addon.inputFrame.frame:ClearAllPoints(true);
	-- addon.inputFrame.frame:SetPoint(DCoordsDB["MainBar"].anchor,DCoordsDB["MainBar"].x,DCoordsDB["MainBar"].y);
	addon.inputFrame.frame:SetPoint("BOTTOMLEFT",DGPS_DB["InputFrame"].x,DGPS_DB["InputFrame"].y);


	-- addon.inputFrame.frame:SetScript("OnLeave", function(self)
	-- 	addon.clearAllEditBoxFocus();
	-- 	addon.saveInputValues();
	-- end);

	-- Drag
    -- OnDragStart
	addon.inputFrame.frame:RegisterForDrag("LeftButton");
	addon.inputFrame.frame:SetScript("OnMouseDown", function(self)
		addon.clearAllEditBoxFocus();

		if (DTools.isInCombat() == false) then
			if (IsShiftKeyDown()) then
				addon.inputFrame.frame:StartMoving();
				addon.inputFrame.frame.dragStarted = true;
			end
		end
	end);

    -- OnDragStop
	addon.inputFrame.frame:SetScript("OnMouseUp", function(self,buttonIdentifier)
		if (addon.inputFrame.frame.dragStarted == true) then
			DGPS_DB["InputFrame"].x = addon.inputFrame.frame:GetLeft();
			DGPS_DB["InputFrame"].y = addon.inputFrame.frame:GetTop()-addon.inputFrame.frame:GetHeight();
			addon.inputFrame.frame:StopMovingOrSizing()
			addon.inputFrame.frame.dragStarted = false
		end

		if (buttonIdentifier == "RightButton") then
			if (DTools.isInCombat() == false) then
				addon.slashCommandHandler("menu")
			end
		end
	end);


	-- Title
	addon.inputFrame.labelTitle = DTools.createText(addon.inputFrame.frame,"DGPS v" .. addon.version,12,"left",5,-5,1,1,1);

	-- Coordinates
	addon.inputFrame.coordinatesFrame = CreateFrame("frame","DGPS_CoordinatesFrame",addon.inputFrame.frame);
    addon.inputFrame.coordinatesFrame:SetFrameStrata("HIGH");
    addon.inputFrame.coordinatesFrame:EnableMouse(true);
	addon.inputFrame.coordinatesFrame:SetResizable(false);
	addon.inputFrame.coordinatesFrame:SetMovable(false);
    addon.inputFrame.coordinatesFrame:SetWidth(addon.inputFrame.frameW);
	addon.inputFrame.coordinatesFrame:SetHeight(20);

	local tex = addon.inputFrame.coordinatesFrame:CreateTexture(nil, "BACKGROUND")
	tex:SetAllPoints(true)
	tex:SetColorTexture(1,0,0,0.1)

	local tileSize = 10;
	local edgeSize = 10;
	local insets = 3;

	addon.inputFrame.coordinatesFrame:SetBackdrop(nil); -- Hide/Remove classic frame
	addon.inputFrame.coordinatesFrame:SetBackdrop({
		bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = true, tileSize = tileSize, edgeSize = edgeSize,
		insets = { left = insets, right = insets, top = insets, bottom = insets }
	})

	addon.inputFrame.coordinatesFrame:ClearAllPoints(true);
	addon.inputFrame.coordinatesFrame:SetPoint("BOTTOMLEFT",0,0);

	-- Coordinates inside coordinates frame which is inside inputFrame
	-- addon.inputFrame.labelCoords = DTools.createText(addon.inputFrame.coordinatesFrame,"0-0",10,"left",6,-5,1,1,1);

	-- Label location
	addon.inputFrame.labelLocation = DTools.createText(addon.inputFrame.coordinatesFrame,"0-0",10,"left",6,-5,1,1,1);

	-- Label coords
	-- addon.inputFrame.labelCoords = DTools.createText(addon.inputFrame.coordinatesFrame,"0-0",10,"left",100,-5,1,1,1);

	-- Label distance
	addon.inputFrame.labelDistance = DTools.createText(addon.inputFrame.coordinatesFrame,"0-0",10,"right",213,-5,1,1,1);



	-- Label for input names
	DTools.createText(addon.inputFrame.frame,"Location",9,"left",6,-19,1,1,1);

	-- Label for input x
	DTools.createText(addon.inputFrame.frame,"X",9,"left",193,-19,1,1,1);

	-- Label for input y
	DTools.createText(addon.inputFrame.frame,"Y",9,"left",250,-19,1,1,1);


	-- -- DTools.createText = function(frame,label,fontSize,justify,x,y,r,g,b,font)
	-- addon.inputFrame.frame.label = addon.inputFrame.frame:CreateFontString(nil, 'ARTWORK');
	-- addon.inputFrame.frame.label:SetPoint("TOPLEFT",frame,"TOPLEFT", 0, 0);
    -- addon.inputFrame.frame.label:SetFont(addon.getMainBarFont(), DCoordsDB["MainBar"].labelFontSize,"OUTLINE");
    -- addon.inputFrame.frame.label:SetShadowOffset(1, -1);
    -- addon.inputFrame.frame.label:SetTextColor(
	-- 	DCoordsDB["MainBar"].labelR,
	-- 	DCoordsDB["MainBar"].labelG,
	-- 	DCoordsDB["MainBar"].labelB
	-- );
    -- addon.inputFrame.frame.label:SetNonSpaceWrap(false);
	-- addon.inputFrame.frame.label:SetText(addon.tempLabel);
	-- addon.inputFrame.frame.label:SetJustifyH("LEFT");
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- setup arrowFrame
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
addon.setupArrowFrame = function()
    -- addon.arrowFrame.frame
	addon.arrowFrame.frame = CreateFrame("frame","DGPS_MainFrame",UIParent);
    addon.arrowFrame.frame:SetFrameStrata("HIGH");
    addon.arrowFrame.frame:EnableMouse(true);
	addon.arrowFrame.frame:SetResizable(true);
	addon.arrowFrame.frame:SetMovable(true);
    addon.arrowFrame.frame:SetWidth(80);
	addon.arrowFrame.frame:SetHeight(80);
	addon.arrowFrame.frame:SetClampedToScreen(true)

	-- addon.arrowFrame.frame.texture = addon.arrowFrame.frame:CreateTexture(nil, "BACKGROUND")
	-- addon.arrowFrame.frame.texture:SetAllPoints(true)
	-- addon.arrowFrame.frame.texture:SetColorTexture(0,0,0,0.2)

	addon.arrowFrame.texture = addon.arrowFrame.frame:CreateTexture(nil,"BACKGROUND")
    addon.arrowFrame.texture:SetTexture("Interface\\AddOns\\DGPS\\gfx\\arrow_classic.tga")
    addon.arrowFrame.texture:SetAllPoints(addon.arrowFrame.frame)
    addon.arrowFrame.frame.texture = addon.arrowFrame.texture


	addon.arrowFrame.frame:ClearAllPoints(true);
	-- addon.arrowFrame.frame:SetPoint(DCoordsDB["MainBar"].anchor,DCoordsDB["MainBar"].x,DCoordsDB["MainBar"].y);
	addon.arrowFrame.frame:SetPoint("BOTTOMLEFT",DGPS_DB["ArrowFrame"].x,DGPS_DB["ArrowFrame"].y);




	-- Drag
    -- OnDragStart
	addon.arrowFrame.frame:RegisterForDrag("LeftButton");
	addon.arrowFrame.frame:SetScript("OnMouseDown", function(self)
		if (DTools.isInCombat() == false) then
			if (IsShiftKeyDown()) then
				addon.arrowFrame.frame:StartMoving();
				addon.arrowFrame.frame.dragStarted = true;
			end
		end
	end);

    -- OnDragStop
	addon.arrowFrame.frame:SetScript("OnMouseUp", function(self,buttonIdentifier)
		if (addon.arrowFrame.frame.dragStarted == true) then
			DGPS_DB["ArrowFrame"].x = addon.arrowFrame.frame:GetLeft();
			DGPS_DB["ArrowFrame"].y = addon.arrowFrame.frame:GetTop()-addon.arrowFrame.frame:GetHeight();
			addon.arrowFrame.frame:StopMovingOrSizing()
			addon.arrowFrame.frame.dragStarted = false
		end

		if (buttonIdentifier == "RightButton") then
			if (DTools.isInCombat() == false) then
				addon.slashCommandHandler("menu")
			end
		end
	end);
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





